
#ifndef __GLOBALMENU_GNOME_PRIVATE_H__
#define __GLOBALMENU_GNOME_PRIVATE_H__

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gmodule.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib-object.h>

G_BEGIN_DECLS

typedef struct _GlobalMenuGNOME GlobalMenuGNOME;

#define GLOBAL_MENU_GTK_TYPE_FLAGS (global_menu_gtk_flags_get_type ())

#define GLOBAL_MENU_GTK_TYPE_SERIALIZER (global_menu_gtk_serializer_get_type ())
#define GLOBAL_MENU_GTK_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOBAL_MENU_GTK_TYPE_SERIALIZER, GlobalMenuGTKSerializer))
#define GLOBAL_MENU_GTK_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GLOBAL_MENU_GTK_TYPE_SERIALIZER, GlobalMenuGTKSerializerClass))
#define GLOBAL_MENU_GTK_IS_SERIALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOBAL_MENU_GTK_TYPE_SERIALIZER))
#define GLOBAL_MENU_GTK_IS_SERIALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GLOBAL_MENU_GTK_TYPE_SERIALIZER))
#define GLOBAL_MENU_GTK_SERIALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GLOBAL_MENU_GTK_TYPE_SERIALIZER, GlobalMenuGTKSerializerClass))

typedef struct _GlobalMenuGTKSerializer GlobalMenuGTKSerializer;
typedef struct _GlobalMenuGTKSerializerClass GlobalMenuGTKSerializerClass;
typedef struct _GlobalMenuGTKSerializerPrivate GlobalMenuGTKSerializerPrivate;
typedef struct _GlobalMenuGTKLocator GlobalMenuGTKLocator;

struct _GlobalMenuGNOME {
};

typedef enum  {
	GLOBAL_MENU_GTK_FLAGS_NONE = 0,
	GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF = 1,
	GLOBAL_MENU_GTK_FLAGS_HYBRID = 2
} GlobalMenuGTKFlags;

struct _GlobalMenuGTKSerializer {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GlobalMenuGTKSerializerPrivate * priv;
};

struct _GlobalMenuGTKSerializerClass {
	GTypeClass parent_class;
	void (*finalize) (GlobalMenuGTKSerializer *self);
};

struct _GlobalMenuGTKLocator {
	int dummy;
};


void gtk_module_init (int* args_length1, char*** args);
char* g_module_check_init (GModule* module);
void g_module_unload (GModule* module);
GlobalMenuGNOME* global_menu_gnome_new (void);
GlobalMenuGNOME* global_menu_gnome_new (void);
GType global_menu_gtk_flags_get_type (void);
GtkWindow* gtk_widget_get_toplevel_window (GtkWidget* widget);
void gdk_window_set_menu_context (GdkWindow* window, const char* context);
char* gdk_window_get_menu_event (GdkWindow* window, GdkAtom atom);
extern gulong global_menu_gtk_changed_hook_id;
extern gulong global_menu_gtk_attached_hook_id;
extern gulong global_menu_gtk_detached_hook_id;
extern gboolean global_menu_gtk_disable_pixbuf;
extern gboolean global_menu_gtk_hybrid;
void global_menu_gtk_init (GlobalMenuGTKFlags flags);
void global_menu_gtk_uninit (void);
gboolean global_menu_gtk_attached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
gboolean global_menu_gtk_detached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
gpointer global_menu_gtk_serializer_ref (gpointer instance);
void global_menu_gtk_serializer_unref (gpointer instance);
GParamSpec* global_menu_gtk_param_spec_serializer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void global_menu_gtk_value_set_serializer (GValue* value, gpointer v_object);
gpointer global_menu_gtk_value_get_serializer (const GValue* value);
GType global_menu_gtk_serializer_get_type (void);
char* global_menu_gtk_serializer_to_string (GtkMenuBar* menubar, gboolean pretty_print);
GtkMenuItem* global_menu_gtk_locator_locate (GtkMenuBar* menubar, const char* path);


G_END_DECLS

#endif
