
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <dyn-patch.h>


#define GLOBAL_MENU_GTK_TYPE_FLAGS (global_menu_gtk_flags_get_type ())

typedef enum  {
	GLOBAL_MENU_GTK_FLAGS_NONE = 0,
	GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF = 1,
	GLOBAL_MENU_GTK_FLAGS_HYBRID = 2
} GlobalMenuGTKFlags;



GType global_menu_gtk_flags_get_type (void);
GtkWindow* gtk_widget_get_toplevel_window (GtkWidget* widget);
void gdk_window_set_menu_context (GdkWindow* window, const char* context);
char* gdk_window_get_menu_event (GdkWindow* window, GdkAtom atom);
extern gulong global_menu_gtk_changed_hook_id;
gulong global_menu_gtk_changed_hook_id = 0UL;
extern gulong global_menu_gtk_attached_hook_id;
gulong global_menu_gtk_attached_hook_id = 0UL;
extern gulong global_menu_gtk_detached_hook_id;
gulong global_menu_gtk_detached_hook_id = 0UL;
extern gboolean global_menu_gtk_disable_pixbuf;
gboolean global_menu_gtk_disable_pixbuf = FALSE;
extern gboolean global_menu_gtk_hybrid;
gboolean global_menu_gtk_hybrid = FALSE;
gboolean global_menu_gtk_changed_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
static gboolean _global_menu_gtk_changed_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self);
gboolean global_menu_gtk_attached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
static gboolean _global_menu_gtk_attached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self);
gboolean global_menu_gtk_detached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values);
static gboolean _global_menu_gtk_detached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self);
void global_menu_gtk_init (GlobalMenuGTKFlags flags);
void global_menu_gtk_unbind_menubar_from_window (GtkMenuBar* menubar, GtkWindow* window);
void global_menu_gtk_uninit (void);
gboolean global_menu_gtk_menubar_should_be_skipped (GtkMenuBar* menubar);
void global_menu_gtk_menubar_set_local (GtkMenuBar* menubar, gboolean value);
void global_menu_gtk_bonobo_plug_widget_hack (GtkWidget* _self_);
void global_menu_gtk_bind_menubar_to_window (GtkMenuBar* menubar, GtkWindow* window);
gboolean global_menu_gtk_menubar_get_local (GtkMenuBar* menubar);
char* global_menu_gtk_serializer_to_string (GtkMenuBar* menubar, gboolean pretty_print);
GtkMenuBar* global_menu_gtk_find_menubar (GtkContainer* widget);
gboolean global_menu_gtk_window_property_notify_event (GtkWindow* window, const GdkEventProperty* event);
static gboolean _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event (GtkWindow* _sender, const GdkEventProperty* event, gpointer self);
void global_menu_gtk_window_realize (GtkWindow* window);
static void _global_menu_gtk_window_realize_gtk_widget_realize (GtkWindow* _sender, gpointer self);
GtkMenuItem* global_menu_gtk_locator_locate (GtkMenuBar* menubar, const char* path);
GtkMenuItem* global_menu_gtk_lookup_item (GtkWindow* window, const char* path);




GType global_menu_gtk_flags_get_type (void) {
	static GType global_menu_gtk_flags_type_id = 0;
	if (G_UNLIKELY (global_menu_gtk_flags_type_id == 0)) {
		static const GEnumValue values[] = {{GLOBAL_MENU_GTK_FLAGS_NONE, "GLOBAL_MENU_GTK_FLAGS_NONE", "none"}, {GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF, "GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF", "disable-pixbuf"}, {GLOBAL_MENU_GTK_FLAGS_HYBRID, "GLOBAL_MENU_GTK_FLAGS_HYBRID", "hybrid"}, {0, NULL, NULL}};
		global_menu_gtk_flags_type_id = g_enum_register_static ("GlobalMenuGTKFlags", values);
	}
	return global_menu_gtk_flags_type_id;
}


static gboolean _global_menu_gtk_changed_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self) {
	return global_menu_gtk_changed_eh (ihint, param_values_length1, param_values);
}


static gboolean _global_menu_gtk_attached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self) {
	return global_menu_gtk_attached_eh (ihint, param_values_length1, param_values);
}


static gboolean _global_menu_gtk_detached_eh_gsignal_emission_hook (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values, gpointer self) {
	return global_menu_gtk_detached_eh (ihint, param_values_length1, param_values);
}


void global_menu_gtk_init (GlobalMenuGTKFlags flags) {
	if ((flags & GLOBAL_MENU_GTK_FLAGS_DISABLE_PIXBUF) != 0) {
		global_menu_gtk_disable_pixbuf = TRUE;
	}
	if ((flags & GLOBAL_MENU_GTK_FLAGS_HYBRID) != 0) {
		global_menu_gtk_hybrid = TRUE;
	}
	global_menu_gtk_changed_hook_id = g_signal_add_emission_hook (g_signal_lookup ("dyn-patch-changed", GTK_TYPE_MENU_BAR), (GQuark) 0, _global_menu_gtk_changed_eh_gsignal_emission_hook, NULL, NULL);
	global_menu_gtk_attached_hook_id = g_signal_add_emission_hook (g_signal_lookup ("dyn-patch-attached", GTK_TYPE_MENU_BAR), (GQuark) 0, _global_menu_gtk_attached_eh_gsignal_emission_hook, NULL, NULL);
	global_menu_gtk_detached_hook_id = g_signal_add_emission_hook (g_signal_lookup ("dyn-patch-detached", GTK_TYPE_MENU_BAR), (GQuark) 0, _global_menu_gtk_detached_eh_gsignal_emission_hook, NULL, NULL);
}


void global_menu_gtk_uninit (void) {
	GList* toplevels;
	g_signal_remove_emission_hook (g_signal_lookup ("dyn-patch-changed", GTK_TYPE_MENU_BAR), global_menu_gtk_changed_hook_id);
	g_signal_remove_emission_hook (g_signal_lookup ("dyn-patch-attached", GTK_TYPE_MENU_BAR), global_menu_gtk_attached_hook_id);
	g_signal_remove_emission_hook (g_signal_lookup ("dyn-patch-detached", GTK_TYPE_MENU_BAR), global_menu_gtk_detached_hook_id);
	toplevels = gtk_window_list_toplevels ();
	{
		GList* toplevel_collection;
		GList* toplevel_it;
		toplevel_collection = toplevels;
		for (toplevel_it = toplevel_collection; toplevel_it != NULL; toplevel_it = toplevel_it->next) {
			GtkWidget* _tmp3_;
			GtkWidget* toplevel;
			_tmp3_ = NULL;
			toplevel = (_tmp3_ = (GtkWidget*) toplevel_it->data, (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
			{
				GtkMenuBar* _tmp0_;
				GtkMenuBar* menubar;
				GtkWidget* _tmp1_;
				if (!GTK_IS_WINDOW (toplevel)) {
					(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
					continue;
				}
				_tmp0_ = NULL;
				menubar = (_tmp0_ = GTK_MENU_BAR (dyn_patch_get_menubar (toplevel)), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
				if (menubar == NULL) {
					(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
					continue;
				}
				_tmp1_ = NULL;
				global_menu_gtk_unbind_menubar_from_window (menubar, (_tmp1_ = toplevel, GTK_IS_WINDOW (_tmp1_) ? ((GtkWindow*) _tmp1_) : NULL));
				gtk_widget_queue_resize ((GtkWidget*) menubar);
				if (0 != (GTK_WIDGET_FLAGS ((GtkWidget*) menubar) & GTK_REALIZED)) {
					gboolean _tmp2_;
					if ((g_object_get ((GtkWidget*) menubar, "visible", &_tmp2_, NULL), _tmp2_)) {
						gtk_widget_unrealize ((GtkWidget*) menubar);
						gtk_widget_map ((GtkWidget*) menubar);
					}
				}
				if (0 != (GTK_WIDGET_FLAGS (toplevel) & GTK_REALIZED)) {
					gdk_window_set_menu_context (toplevel->window, NULL);
				}
				(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
				(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
			}
		}
	}
	(toplevels == NULL) ? NULL : (toplevels = (g_list_free (toplevels), NULL));
}


gboolean global_menu_gtk_attached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values) {
	GtkMenuBar* _tmp3_;
	GValue _tmp1_ = {0};
	GObject* _tmp2_;
	GtkMenuBar* menubar;
	GtkWindow* _tmp6_;
	GValue _tmp4_ = {0};
	GObject* _tmp5_;
	GtkWindow* window;
	gboolean _tmp7_;
	if ((*ihint).run_type != G_SIGNAL_RUN_FIRST) {
		return TRUE;
	}
	_tmp3_ = NULL;
	_tmp2_ = NULL;
	menubar = (_tmp3_ = (_tmp2_ = g_value_get_object ((_tmp1_ = param_values[0], &_tmp1_)), GTK_IS_MENU_BAR (_tmp2_) ? ((GtkMenuBar*) _tmp2_) : NULL), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
	_tmp6_ = NULL;
	_tmp5_ = NULL;
	window = (_tmp6_ = (_tmp5_ = g_value_get_object ((_tmp4_ = param_values[1], &_tmp4_)), GTK_IS_WINDOW (_tmp5_) ? ((GtkWindow*) _tmp5_) : NULL), (_tmp6_ == NULL) ? NULL : g_object_ref (_tmp6_));
	g_debug ("globalmenu.vala:76: attached_eh menubar %p to window %p", menubar, window);
	if (global_menu_gtk_menubar_should_be_skipped (menubar)) {
		global_menu_gtk_menubar_set_local (menubar, TRUE);
	} else {
		global_menu_gtk_menubar_set_local (menubar, FALSE);
		global_menu_gtk_bonobo_plug_widget_hack ((GtkWidget*) menubar);
	}
	global_menu_gtk_bind_menubar_to_window (menubar, window);
	return (_tmp7_ = TRUE, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), (window == NULL) ? NULL : (window = (g_object_unref (window), NULL)), _tmp7_);
}


gboolean global_menu_gtk_detached_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values) {
	GtkMenuBar* _tmp3_;
	GValue _tmp1_ = {0};
	GObject* _tmp2_;
	GtkMenuBar* menubar;
	GtkWindow* _tmp6_;
	GValue _tmp4_ = {0};
	GObject* _tmp5_;
	GtkWindow* window;
	gboolean _tmp7_;
	if ((*ihint).run_type != G_SIGNAL_RUN_FIRST) {
		return TRUE;
	}
	_tmp3_ = NULL;
	_tmp2_ = NULL;
	menubar = (_tmp3_ = (_tmp2_ = g_value_get_object ((_tmp1_ = param_values[0], &_tmp1_)), GTK_IS_MENU_BAR (_tmp2_) ? ((GtkMenuBar*) _tmp2_) : NULL), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
	_tmp6_ = NULL;
	_tmp5_ = NULL;
	window = (_tmp6_ = (_tmp5_ = g_value_get_object ((_tmp4_ = param_values[1], &_tmp4_)), GTK_IS_WINDOW (_tmp5_) ? ((GtkWindow*) _tmp5_) : NULL), (_tmp6_ == NULL) ? NULL : g_object_ref (_tmp6_));
	g_debug ("globalmenu.vala:93: detached_eh menubar %p from window %p", menubar, window);
	global_menu_gtk_unbind_menubar_from_window (menubar, window);
	return (_tmp7_ = TRUE, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), (window == NULL) ? NULL : (window = (g_object_unref (window), NULL)), _tmp7_);
}


gboolean global_menu_gtk_changed_eh (const GSignalInvocationHint* ihint, int param_values_length1, GValue* param_values) {
	GtkMenuBar* _tmp2_;
	GValue _tmp0_ = {0};
	GObject* _tmp1_;
	GtkMenuBar* _self_;
	gboolean _tmp7_;
	_tmp2_ = NULL;
	_tmp1_ = NULL;
	_self_ = (_tmp2_ = (_tmp1_ = g_value_get_object ((_tmp0_ = param_values[0], &_tmp0_)), GTK_IS_MENU_BAR (_tmp1_) ? ((GtkMenuBar*) _tmp1_) : NULL), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
	if (_self_ != NULL) {
		GtkWindow* _tmp5_;
		GtkWindow* toplevel;
		if (global_menu_gtk_menubar_get_local (_self_)) {
			gboolean _tmp3_;
			return (_tmp3_ = TRUE, (_self_ == NULL) ? NULL : (_self_ = (g_object_unref (_self_), NULL)), _tmp3_);
		}
		if ((*ihint).run_type != G_SIGNAL_RUN_FIRST) {
			gboolean _tmp4_;
			return (_tmp4_ = TRUE, (_self_ == NULL) ? NULL : (_self_ = (g_object_unref (_self_), NULL)), _tmp4_);
		}
		_tmp5_ = NULL;
		toplevel = (_tmp5_ = dyn_patch_get_window (_self_), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_));
		if (toplevel != NULL) {
			if (0 != (GTK_WIDGET_FLAGS ((GtkWidget*) toplevel) & GTK_REALIZED)) {
				char* _tmp6_;
				_tmp6_ = NULL;
				gdk_window_set_menu_context (((GtkWidget*) toplevel)->window, _tmp6_ = global_menu_gtk_serializer_to_string (_self_, FALSE));
				_tmp6_ = (g_free (_tmp6_), NULL);
			}
		}
		g_debug ("globalmenu.vala:114: changed_eh");
		(toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL));
	}
	return (_tmp7_ = TRUE, (_self_ == NULL) ? NULL : (_self_ = (g_object_unref (_self_), NULL)), _tmp7_);
}


gboolean global_menu_gtk_menubar_should_be_skipped (GtkMenuBar* menubar) {
	GtkWidget* parent;
	GType panel_applet_type;
	GType gnomenu_menu_bar_type;
	GType panel_menu_bar_type;
	GType gtk_notebook_type;
	g_return_val_if_fail (menubar != NULL, FALSE);
	parent = (GtkWidget*) menubar;
	panel_applet_type = g_type_from_name ("PanelApplet");
	gnomenu_menu_bar_type = g_type_from_name ("GnomenuMenuBar");
	panel_menu_bar_type = g_type_from_name ("PanelMenuBar");
	gtk_notebook_type = g_type_from_name ("GtkNotebook");
	while (GTK_IS_WIDGET (parent)) {
		GType type;
		gboolean _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
		type = G_TYPE_FROM_INSTANCE ((GObject*) parent);
		_tmp0_ = FALSE;
		_tmp1_ = FALSE;
		_tmp2_ = FALSE;
		if (g_type_is_a (type, panel_applet_type)) {
			_tmp2_ = TRUE;
		} else {
			_tmp2_ = g_type_is_a (type, gnomenu_menu_bar_type);
		}
		if (_tmp2_) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = g_type_is_a (type, panel_menu_bar_type);
		}
		if (_tmp1_) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = g_type_is_a (type, gtk_notebook_type);
		}
		if (_tmp0_) {
			g_debug ("globalmenu.vala:133: menu bar skipped");
			return TRUE;
		}
		parent = (GtkWidget*) gtk_widget_get_parent (parent);
	}
	g_debug ("globalmenu.vala:138: not skipped");
	return FALSE;
}


void global_menu_gtk_bonobo_plug_widget_hack (GtkWidget* _self_) {
	GtkWidget* parent;
	g_return_if_fail (_self_ != NULL);
	parent = (GtkWidget*) gtk_widget_get_parent (_self_);
	while (GTK_IS_WIDGET (parent)) {
		const char* typename;
		typename = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) parent));
		if (strstr (typename, "BonoboDockBand") != NULL) {
			g_debug ("globalmenu.vala:147: Hiding %s", typename);
			gtk_widget_hide (parent);
			break;
		}
		parent = (GtkWidget*) gtk_widget_get_parent (parent);
	}
}


gboolean global_menu_gtk_menubar_get_local (GtkMenuBar* menubar) {
	gboolean is_local;
	g_return_val_if_fail (menubar != NULL, FALSE);
	is_local = TRUE;
	g_object_get ((GObject*) menubar, "local", &is_local, NULL, NULL);
	return is_local;
}


void global_menu_gtk_menubar_set_local (GtkMenuBar* menubar, gboolean value) {
	g_return_if_fail (menubar != NULL);
	g_object_set ((GObject*) menubar, "local", value, NULL, NULL);
}


GtkMenuBar* global_menu_gtk_find_menubar (GtkContainer* widget) {
	GList* children;
	GtkMenuBar* _tmp7_;
	g_return_val_if_fail (widget != NULL, NULL);
	children = gtk_container_get_children (widget);
	{
		GList* child_collection;
		GList* child_it;
		child_collection = children;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp6_;
			GtkWidget* child;
			_tmp6_ = NULL;
			child = (_tmp6_ = (GtkWidget*) child_it->data, (_tmp6_ == NULL) ? NULL : g_object_ref (_tmp6_));
			{
				if (GTK_IS_MENU_BAR (child)) {
					GtkMenuBar* _tmp1_;
					GtkWidget* _tmp0_;
					GtkMenuBar* menubar;
					_tmp1_ = NULL;
					_tmp0_ = NULL;
					menubar = (_tmp1_ = (_tmp0_ = child, GTK_IS_MENU_BAR (_tmp0_) ? ((GtkMenuBar*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
					if (global_menu_gtk_menubar_should_be_skipped (menubar)) {
						GtkMenuBar* _tmp2_;
						global_menu_gtk_menubar_set_local (menubar, TRUE);
						_tmp2_ = NULL;
						return (_tmp2_ = NULL, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), (child == NULL) ? NULL : (child = (g_object_unref (child), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp2_);
					} else {
						GtkMenuBar* _tmp3_;
						global_menu_gtk_menubar_set_local (menubar, FALSE);
						_tmp3_ = NULL;
						return (_tmp3_ = menubar, (child == NULL) ? NULL : (child = (g_object_unref (child), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp3_);
					}
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
				}
				if (GTK_IS_CONTAINER (child)) {
					GtkWidget* _tmp4_;
					GtkMenuBar* menubar;
					_tmp4_ = NULL;
					menubar = global_menu_gtk_find_menubar ((_tmp4_ = child, GTK_IS_CONTAINER (_tmp4_) ? ((GtkContainer*) _tmp4_) : NULL));
					if (menubar != NULL) {
						GtkMenuBar* _tmp5_;
						_tmp5_ = NULL;
						return (_tmp5_ = menubar, (child == NULL) ? NULL : (child = (g_object_unref (child), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp5_);
					}
					(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
				}
				(child == NULL) ? NULL : (child = (g_object_unref (child), NULL));
			}
		}
	}
	_tmp7_ = NULL;
	return (_tmp7_ = NULL, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), _tmp7_);
}


static gboolean _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event (GtkWindow* _sender, const GdkEventProperty* event, gpointer self) {
	return global_menu_gtk_window_property_notify_event (_sender, event);
}


static void _global_menu_gtk_window_realize_gtk_widget_realize (GtkWindow* _sender, gpointer self) {
	global_menu_gtk_window_realize (_sender);
}


void global_menu_gtk_unbind_menubar_from_window (GtkMenuBar* menubar, GtkWindow* window) {
	guint _tmp0_;
	guint _tmp1_;
	g_return_if_fail (menubar != NULL);
	g_return_if_fail (window != NULL);
	g_signal_handlers_disconnect_matched ((GtkWidget*) window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("property-notify-event", GTK_TYPE_WIDGET, &_tmp0_, NULL, FALSE), _tmp0_), 0, NULL, (GCallback) _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event, NULL);
	g_signal_handlers_disconnect_matched ((GtkWidget*) window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("realize", GTK_TYPE_WIDGET, &_tmp1_, NULL, FALSE), _tmp1_), 0, NULL, (GCallback) _global_menu_gtk_window_realize_gtk_widget_realize, NULL);
	g_debug ("globalmenu.vala:190: Unbind bar %p from window %p", menubar, window);
}


void global_menu_gtk_bind_menubar_to_window (GtkMenuBar* menubar, GtkWindow* window) {
	g_return_if_fail (menubar != NULL);
	g_return_if_fail (window != NULL);
	gtk_widget_add_events ((GtkWidget*) window, (gint) GDK_PROPERTY_CHANGE_MASK);
	g_signal_connect ((GtkWidget*) window, "property-notify-event", (GCallback) _global_menu_gtk_window_property_notify_event_gtk_widget_property_notify_event, NULL);
	g_signal_connect ((GtkWidget*) window, "realize", (GCallback) _global_menu_gtk_window_realize_gtk_widget_realize, NULL);
	g_debug ("globalmenu.vala:197: Bind bar %p from window %p", menubar, window);
}


void global_menu_gtk_window_realize (GtkWindow* window) {
	GtkMenuBar* _tmp0_;
	GtkMenuBar* menubar;
	g_return_if_fail (window != NULL);
	_tmp0_ = NULL;
	menubar = (_tmp0_ = dyn_patch_get_menubar ((GtkWidget*) window), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	g_signal_emit_by_name (menubar, "dyn-patch-changed", GTK_TYPE_WIDGET, menubar, NULL, NULL);
	(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
}


GtkMenuItem* global_menu_gtk_lookup_item (GtkWindow* window, const char* path) {
	GtkMenuBar* _tmp0_;
	GtkMenuBar* menubar;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = NULL;
	menubar = (_tmp0_ = dyn_patch_get_menubar ((GtkWidget*) window), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	g_debug ("globalmenu.vala:208: path = %s", path);
	if (menubar != NULL) {
		GtkMenuItem* item;
		item = global_menu_gtk_locator_locate (menubar, path);
		if (item != NULL) {
			GtkMenuItem* _tmp1_;
			g_debug ("globalmenu.vala:212: item %p is activated", item);
			_tmp1_ = NULL;
			return (_tmp1_ = item, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), _tmp1_);
		} else {
			GtkMenuItem* _tmp2_;
			g_warning ("globalmenu.vala:215: item lookup failure");
			_tmp2_ = NULL;
			return (_tmp2_ = NULL, (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), _tmp2_);
		}
		(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
	} else {
		GtkMenuItem* _tmp3_;
		g_warning ("globalmenu.vala:219: menubar lookup failure");
		_tmp3_ = NULL;
		return (_tmp3_ = NULL, (menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL)), _tmp3_);
	}
	(menubar == NULL) ? NULL : (menubar = (g_object_unref (menubar), NULL));
}


gboolean global_menu_gtk_window_property_notify_event (GtkWindow* window, const GdkEventProperty* event) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (window != NULL, FALSE);
	if ((*event).atom == gdk_atom_intern ("_NET_GLOBALMENU_MENU_EVENT", FALSE)) {
		char* path;
		GtkMenuItem* item;
		path = gdk_window_get_menu_event (((GtkWidget*) window)->window, (*event).atom);
		item = global_menu_gtk_lookup_item (window, path);
		if (item != NULL) {
			gtk_menu_item_activate (item);
		}
		path = (g_free (path), NULL);
		(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
	}
	_tmp0_ = FALSE;
	if ((*event).atom == gdk_atom_intern ("_NET_GLOBALMENU_MENU_HIGHLIGHT", FALSE)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = (*event).atom == gdk_atom_intern ("_NET_GLOBALMENU_MENU_SELECT", FALSE);
	}
	if (_tmp0_) {
		char* path;
		GtkMenuItem* item;
		path = gdk_window_get_menu_event (((GtkWidget*) window)->window, (*event).atom);
		item = global_menu_gtk_lookup_item (window, path);
		if (item != NULL) {
			gtk_item_select ((GtkItem*) item);
			g_debug ("globalmenu.vala:236: item %p is selected", item);
			if (gtk_menu_item_get_submenu (item) != NULL) {
				if (global_menu_gtk_hybrid == FALSE) {
					gtk_widget_show ((GtkWidget*) gtk_menu_item_get_submenu (item));
				} else {
					g_debug ("globalmenu.vala:241: client side popup");
					gtk_menu_popup (gtk_menu_item_get_submenu (item), NULL, NULL, NULL, NULL, (guint) 3, gtk_get_current_event_time ());
				}
			}
		}
		path = (g_free (path), NULL);
		(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
	}
	_tmp1_ = FALSE;
	if ((*event).atom == gdk_atom_intern ("_NET_GLOBALMENU_MENU_DEHIGHLIGHT", FALSE)) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*event).atom == gdk_atom_intern ("_NET_GLOBALMENU_MENU_DESELECT", FALSE);
	}
	if (_tmp1_) {
		char* path;
		GtkMenuItem* item;
		path = gdk_window_get_menu_event (((GtkWidget*) window)->window, (*event).atom);
		item = global_menu_gtk_lookup_item (window, path);
		if (item != NULL) {
			gtk_item_deselect ((GtkItem*) item);
			g_debug ("globalmenu.vala:256: item %p is selected", item);
			if (gtk_menu_item_get_submenu (item) != NULL) {
				if (global_menu_gtk_hybrid == FALSE) {
					gtk_widget_hide ((GtkWidget*) gtk_menu_item_get_submenu (item));
				} else {
					g_debug ("globalmenu.vala:261: client side popup");
					gtk_menu_popdown (gtk_menu_item_get_submenu (item));
				}
			}
		}
		path = (g_free (path), NULL);
		(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
	}
	return FALSE;
}




